  PROGRAM

!   
DWORD                        EQUATE(ULONG)
WORD                         EQUATE(USHORT)

HFILE                        EQUATE(SIGNED)
HFILE_ERROR                  EQUATE(-1)
OFS_MAXPATHNAME              EQUATE(128)

!      CBinFile.Seek(...)
SEEK_SET                     EQUATE(0)
SEEK_CUR                     EQUATE(1)
SEEK_END                     EQUATE(2)

!     CBinFile.Open(...)
OFSTRUCT                     GROUP,TYPE
cBytes                         BYTE                        !    
cFixedDisk                     BYTE                        !  0,    
nErrCode                       USHORT                      !   MS-DOS    
Reserved1                      USHORT                      ! 
Reserved2                      USHORT                      ! 
szPathName                     STRING(OFS_MAXPATHNAME)     !     
                             END

!    ()  CBinFile.Open(...)
OF_CREATE                    EQUATE(1000h)                 ! 
OF_READ                      EQUATE(0000h)                 !  
OF_WRITE                     EQUATE(0001h)                 !  
OF_READWRITE                 EQUATE(0002h)                 !    
OF_SHARE_DENY_NONE           EQUATE(0040h)                 !   
OF_SHARE_DENY_READ           EQUATE(0030h)                 !    
OF_SHARE_DENY_WRITE          EQUATE(0020h)                 !    

! WMF
PLACEABLEMETAHEADER          GROUP,TYPE
Key                            DWORD                       ! Magic number (always 9AC6CDD7h)
Handle                         WORD                        ! Metafile HANDLE number (always 0)
Left                           SHORT                       ! Left coordinate in metafile units
Top                            SHORT                       ! Top coordinate in metafile units
Right                          SHORT                       ! Right coordinate in metafile units
Bottom                         SHORT                       ! Bottom coordinate in metafile units
Inch                           WORD                        ! Number of metafile units per inch
Reserved                       DWORD                       ! Reserved (always 0)
Checksum                       WORD                        ! Checksum value for previous 10 WORDs
                             END

WMFHEAD                      GROUP,TYPE
FileType                       WORD                        ! Type of metafile (0=memory, 1=disk)
HeaderSize                     WORD                        ! Size of header in WORDS (always 9)
Version                        WORD                        ! Version of Microsoft Windows used
FileSize                       DWORD                       ! Total size of the metafile in WORDs
NumOfObjects                   WORD                        ! Number of objects in the file
MaxRecordSize                  DWORD                       ! The size of largest record in WORDs
NumOfParams                    WORD                        ! Not Used (always 0)
                             END

 MAP
    WMFChangeString          (STRING WmfName, STRING FromString, STRING ToString, BYTE OnlyFirst = TRUE),BYTE,PROC
    MODULE('WINAPI_FUNC_FILE')
      OpenFile               (*CSTRING,*OFSTRUCT,UNSIGNED),HFILE,PASCAL,RAW
      Access                 (*CSTRING,SIGNED),SIGNED,RAW,NAME('_access')
      GetLastError           (),ULONG,PASCAL
      _lread                 (HFILE, ULONG, UNSIGNED),UNSIGNED,PASCAL,RAW,PROC
      _lwrite                (HFILE, ULONG, UNSIGNED),UNSIGNED,PASCAL,RAW
      _lclose                (HFILE),HFILE,PASCAL,PROC
      _llseek                (HFILE,LONG,SIGNED),LONG,PASCAL,PROC
    END
 END

!****************************************************************************************************************************
  CODE
  WMFChangeString('c:\temp\test2.wmf','ZZZZZZZZZZ', '1234567TTT')
!****************************************************************************************************************************
WMFChangeString              PROCEDURE(STRING WmfName, STRING FromString, STRING ToString, BYTE OnlyFirst = TRUE)

FileHnd                      HFILE
InOf                         LIKE(OFSTRUCT)
CWmfName                     CSTRING(260)

TmpCString                   &STRING

!  
AldusHdr                     LIKE(PLACEABLEMETAHEADER)
StdHdr                       LIKE(WMFHEAD)

DataLen                      LONG

TmpGDI                       GROUP                    !   
Size                           DWORD
Cmd                            WORD
                             END

FindPos                      LONG
CurPos                       LONG
RetValue                     BYTE

  CODE

  IF LEN(FromString) = LEN(ToString)
     ! Open WMF
     CWmfName = CLIP(WmfName)
     FileHnd  = OpenFile(CWmfName, InOf, OF_READWRITE )

     IF FileHnd <> HFILE_ERROR                      !   

        !  ALDUSHEADER
        IF (_lread(FileHnd, ADDRESS(AldusHdr), SIZE(PLACEABLEMETAHEADER)) = SIZE(PLACEABLEMETAHEADER))

           IF AldusHdr.Key! = 9AC6CDD7H              !   (Placeable metafile format)

              !  StdHdr
              IF (_lread(FileHnd, ADDRESS(StdHdr), SIZE(WMFHEAD)) = SIZE(WMFHEAD))

                 RetValue = TRUE

                 !  GDI 
                 LOOP WHILE _lread(FileHnd, ADDRESS(TmpGDI), 6) = 6 AND TmpGDI.Cmd
                    DataLen = (TmpGDI.Size - 3) * 2

                    IF TmpGDI.Cmd = 0A32H !               ! GDI command ExtTextOut
                       TmpCString &= NEW STRING(DataLen)
                       CurPos      = _llseek(FileHnd, 0, SEEK_CUR)
                       _lread(FileHnd, ADDRESS(TmpCString), DataLen)

                       FindPos = INSTRING(FromString, TmpCString, 1, 1)
                       IF FindPos
                          TmpCString[FindPos : LEN(FromString) + FindPos - 1] = ToString
                          _llseek(FileHnd, CurPos, 0)
                          _lwrite(FileHnd, ADDRESS(TmpCString), DataLen)
                       END

                       DISPOSE(TmpCString)
                    ELSE
                       _llseek(FileHnd, DataLen, SEEK_CUR)
                    END
                 END
              ELSE
                 MESSAGE('Read error: ' & CLIP(WmfName))
              END

           ELSE
              MESSAGE('File: ' & CLIP(WmfName) & '|is not formatted as "Placeable metafile format"')
           END

        ELSE
           MESSAGE('Read error: ' & CLIP(WmfName))
        END
        _lclose(FileHnd)                            !  
     ELSE
        MESSAGE('Open error: ' & CLIP(WmfName))
     END
  ELSE
     MESSAGE('Must be: LEN(FromString) = LEN(ToString)', 'WMFChangeString', ICON:Exclamation)
  END

  RETURN RetValue
!****************************************************************************************************************************
